var W = Object.defineProperty;
var K = (e, t, s) => t in e ? W(e, t, { enumerable: !0, configurable: !0, writable: !0, value: s }) : e[t] = s;
var l = (e, t, s) => (K(e, typeof t != "symbol" ? t + "" : t, s), s);
import "./vue-slider-range.css";
import { defineComponent as C, openBlock as u, createElementBlock as p, normalizeClass as y, renderSlot as c, createElementVNode as k, normalizeStyle as g, toDisplayString as j, createCommentVNode as B, resolveComponent as z, mergeProps as M, Fragment as R, renderList as O, normalizeProps as S, guardReactiveProps as D, createBlock as F, withCtx as $ } from "vue";
const q = C({
  name: "VueSliderDot",
  emits: ["drag-start"],
  props: {
    value: { type: [String, Number], default: 0 },
    tooltip: {
      type: String,
      required: !0
    },
    tooltipPlacement: {
      type: String,
      validator: (e) => ["top", "right", "bottom", "left"].indexOf(e) > -1,
      required: !0
    },
    tooltipFormatter: {
      type: [String, Function]
    },
    focus: { type: Boolean, default: !1 },
    disabled: { type: Boolean, default: !1 },
    dotStyle: { type: Object },
    tooltipStyle: { type: Object }
  },
  computed: {
    dotClasses() {
      return [
        "vue-slider-dot",
        {
          "vue-slider-dot-hover": this.tooltip === "hover" || this.tooltip === "active",
          "vue-slider-dot-disabled": this.disabled,
          "vue-slider-dot-focus": this.focus
        }
      ];
    },
    handleClasses() {
      return [
        "vue-slider-dot-handle",
        {
          "vue-slider-dot-handle-disabled": this.disabled,
          "vue-slider-dot-handle-focus": this.focus
        }
      ];
    },
    tooltipClasses() {
      return [
        "vue-slider-dot-tooltip",
        [`vue-slider-dot-tooltip-${this.tooltipPlacement}`],
        {
          "vue-slider-dot-tooltip-show": this.showTooltip
        }
      ];
    },
    tooltipInnerClasses() {
      return [
        "vue-slider-dot-tooltip-inner",
        [`vue-slider-dot-tooltip-inner-${this.tooltipPlacement}`],
        {
          "vue-slider-dot-tooltip-inner-disabled": this.disabled,
          "vue-slider-dot-tooltip-inner-focus": this.focus
        }
      ];
    },
    showTooltip() {
      switch (this.tooltip) {
        case "always":
          return !0;
        case "none":
          return !1;
        case "focus":
        case "active":
          return !!this.focus;
        default:
          return !1;
      }
    },
    tooltipValue() {
      return this.tooltipFormatter ? typeof this.tooltipFormatter == "string" ? this.tooltipFormatter.replace(/\{value\}/, String(this.value)) : this.tooltipFormatter(this.value) : this.value;
    }
  },
  methods: {
    dragStart() {
      if (this.disabled)
        return !1;
      this.$emit("drag-start");
    }
  }
}), E = (e, t) => {
  const s = e.__vccOpts || e;
  for (const [i, r] of t)
    s[i] = r;
  return s;
}, X = ["aria-valuetext"], G = { class: "vue-slider-dot-tooltip-text" };
function Z(e, t, s, i, r, n) {
  var a;
  return u(), p("div", {
    ref: "dot",
    class: y(e.dotClasses),
    "aria-valuetext": (a = e.tooltipValue) == null ? void 0 : a.toString(),
    onMousedownPassive: t[0] || (t[0] = (...m) => e.dragStart && e.dragStart(...m)),
    onTouchstartPassive: t[1] || (t[1] = (...m) => e.dragStart && e.dragStart(...m))
  }, [
    c(e.$slots, "dot", {}, () => [
      k("div", {
        class: y(e.handleClasses),
        style: g(e.dotStyle)
      }, null, 6)
    ]),
    e.tooltip !== "none" ? (u(), p("div", {
      key: 0,
      class: y(e.tooltipClasses)
    }, [
      c(e.$slots, "tooltip", {}, () => [
        k("div", {
          class: y(e.tooltipInnerClasses),
          style: g(e.tooltipStyle)
        }, [
          k("span", G, j(e.tooltipValue), 1)
        ], 6)
      ])
    ], 2)) : B("", !0)
  ], 42, X);
}
const H = /* @__PURE__ */ E(q, [["render", Z]]), J = C({
  name: "VueSliderMark",
  emits: ["press-label"],
  props: {
    mark: {
      type: Object,
      required: !0
    },
    hideLabel: { type: Boolean },
    stepStyle: { type: Object, default: () => ({}) },
    stepActiveStyle: { type: Object, default: () => ({}) },
    labelStyle: { type: Object, default: () => ({}) },
    labelActiveStyle: { type: Object, default: () => ({}) }
  },
  computed: {
    marksClasses() {
      return [
        "vue-slider-mark",
        {
          "vue-slider-mark-active": this.mark.active
        }
      ];
    },
    stepClasses() {
      return [
        "vue-slider-mark-step",
        {
          "vue-slider-mark-step-active": this.mark.active
        }
      ];
    },
    labelClasses() {
      return [
        "vue-slider-mark-label",
        {
          "vue-slider-mark-label-active": this.mark.active
        }
      ];
    }
  },
  methods: {
    labelClickHandle(e) {
      e.stopPropagation(), this.$emit("press-label", this.mark.pos);
    }
  }
});
function Q(e, t, s, i, r, n) {
  return u(), p("div", {
    class: y(e.marksClasses)
  }, [
    c(e.$slots, "step", {}, () => [
      k("div", {
        class: y(e.stepClasses),
        style: g([
          e.stepStyle,
          e.mark.style || {},
          e.mark.active && e.stepActiveStyle ? e.stepActiveStyle : {},
          e.mark.active && e.mark.activeStyle ? e.mark.activeStyle : {}
        ])
      }, null, 6)
    ]),
    e.hideLabel ? B("", !0) : c(e.$slots, "label", { key: 0 }, () => [
      k("div", {
        class: y(e.labelClasses),
        style: g([
          e.labelStyle,
          e.mark.labelStyle || {},
          e.mark.active && e.labelActiveStyle ? e.labelActiveStyle : {},
          e.mark.active && e.mark.labelActiveStyle ? e.mark.labelActiveStyle : {}
        ]),
        onClick: t[0] || (t[0] = (...a) => e.labelClickHandle && e.labelClickHandle(...a))
      }, j(e.mark.label), 7)
    ])
  ], 2);
}
const N = /* @__PURE__ */ E(J, [["render", Q]]), A = (e) => typeof e == "number" ? `${e}px` : e, Y = (e) => {
  const t = document.documentElement, s = document.body, i = e.getBoundingClientRect();
  return {
    y: i.top + (window.pageYOffset || t.scrollTop) - (t.clientTop || s.clientTop || 0),
    x: i.left + (window.pageXOffset || t.scrollLeft) - (t.clientLeft || s.clientLeft || 0)
  };
}, _ = (e, t, s, i = 1) => {
  const r = "targetTouches" in e ? e.targetTouches[0] : e, n = Y(t), a = {
    x: r.pageX - n.x,
    y: r.pageY - n.y
  };
  return {
    x: s ? t.offsetWidth * i - a.x : a.x,
    y: s ? t.offsetHeight * i - a.y : a.y
  };
}, tt = (e, t) => {
  if (t.hook) {
    const s = t.hook(e);
    if (typeof s == "function")
      return s;
    if (!s)
      return null;
  }
  switch (e.keyCode) {
    case 38:
      return (s) => t.direction === "ttb" ? s - 1 : s + 1;
    case 39:
      return (s) => t.direction === "rtl" ? s - 1 : s + 1;
    case 40:
      return (s) => t.direction === "ttb" ? s + 1 : s - 1;
    case 37:
      return (s) => t.direction === "rtl" ? s + 1 : s - 1;
    case 35:
      return () => t.max;
    case 36:
      return () => t.min;
    case 33:
      return (s) => s + 10;
    case 34:
      return (s) => s - 10;
    default:
      return null;
  }
};
class f {
  constructor(t) {
    l(this, "num");
    this.num = t;
  }
  decimal(t, s) {
    const i = this.num, r = this.getDecimalLen(i), n = this.getDecimalLen(t);
    let a = 0;
    switch (s) {
      case "+":
        a = this.getExponent(r, n), this.num = (this.safeRoundUp(i, a) + this.safeRoundUp(t, a)) / a;
        break;
      case "-":
        a = this.getExponent(r, n), this.num = (this.safeRoundUp(i, a) - this.safeRoundUp(t, a)) / a;
        break;
      case "*":
        this.num = this.safeRoundUp(
          this.safeRoundUp(i, this.getExponent(r)),
          this.safeRoundUp(t, this.getExponent(n))
        ) / this.getExponent(r + n);
        break;
      case "/":
        a = this.getExponent(r, n), this.num = this.safeRoundUp(i, a) / this.safeRoundUp(t, a);
        break;
      case "%":
        a = this.getExponent(r, n), this.num = this.safeRoundUp(i, a) % this.safeRoundUp(t, a) / a;
        break;
    }
    return this;
  }
  plus(t) {
    return this.decimal(t, "+");
  }
  minus(t) {
    return this.decimal(t, "-");
  }
  multiply(t) {
    return this.decimal(t, "*");
  }
  divide(t) {
    return this.decimal(t, "/");
  }
  remainder(t) {
    return this.decimal(t, "%");
  }
  toNumber() {
    return this.num;
  }
  getDecimalLen(t) {
    const s = `${t}`.split("e");
    return (`${s[0]}`.split(".")[1] || "").length - (s[1] ? +s[1] : 0);
  }
  getExponent(t, s) {
    return Math.pow(10, s !== void 0 ? Math.max(t, s) : t);
  }
  // fix: 9999999.99995 * 100000 = 999999999994.9999
  safeRoundUp(t, s) {
    return Math.round(t * s);
  }
}
var et = /* @__PURE__ */ ((e) => (e[e.VALUE = 1] = "VALUE", e[e.INTERVAL = 2] = "INTERVAL", e[e.MIN = 3] = "MIN", e[e.MAX = 4] = "MAX", e[e.ORDER = 5] = "ORDER", e))(et || {});
const st = {
  1: 'The type of the "value" is illegal',
  2: 'The prop "interval" is invalid, "(max - min)" must be divisible by "interval"',
  3: 'The "value" must be greater than or equal to the "min".',
  4: 'The "value" must be less than or equal to the "max".',
  5: 'When "order" is false, the parameters "minRange", "maxRange", "fixed", "enabled" are invalid.'
};
class it {
  constructor(t) {
    l(this, "dotsPos", []);
    // The position of each slider
    l(this, "dotsValue", []);
    // The value of each slider
    l(this, "data");
    l(this, "enableCross");
    l(this, "fixed");
    l(this, "max");
    l(this, "min");
    l(this, "interval");
    l(this, "minRange");
    l(this, "maxRange");
    l(this, "order");
    l(this, "marks");
    l(this, "included");
    l(this, "process");
    l(this, "adsorb");
    l(this, "dotOptions");
    l(this, "onError");
    l(this, "cacheRangeDir", {});
    this.data = t.data, this.max = t.max, this.min = t.min, this.interval = t.interval, this.order = t.order, this.marks = t.marks, this.included = t.included, this.process = t.process, this.adsorb = t.adsorb, this.dotOptions = t.dotOptions, this.onError = t.onError, this.order ? (this.minRange = t.minRange || 0, this.maxRange = t.maxRange || 0, this.enableCross = t.enableCross, this.fixed = t.fixed) : ((t.minRange || t.maxRange || !t.enableCross || t.fixed) && this.emitError(
      5
      /* ORDER */
    ), this.minRange = 0, this.maxRange = 0, this.enableCross = !0, this.fixed = !1), this.setValue(t.value);
  }
  setValue(t) {
    this.setDotsValue(Array.isArray(t) ? [...t] : [t], !0);
  }
  setDotsValue(t, s) {
    this.dotsValue = t, s && this.syncDotsPos();
  }
  // Set the slider position
  setDotsPos(t) {
    const s = this.order ? [...t].sort((i, r) => i - r) : t;
    this.dotsPos = s, this.setDotsValue(
      s.map((i) => this.getValueByPos(i)),
      this.adsorb
    );
  }
  // Get value by position
  getValueByPos(t) {
    let s = this.parsePos(t);
    if (this.included) {
      let i = 100;
      this.markList.forEach((r) => {
        const n = Math.abs(r.pos - t);
        n < i && (i = n, s = r.value);
      });
    }
    return s;
  }
  // Sync slider position
  syncDotsPos() {
    this.dotsPos = this.dotsValue.map((t) => this.parseValue(t));
  }
  /**
   * Get all the marks
   *
   * @readonly
   * @type {Mark[]}
   * @memberof Control
   */
  get markList() {
    if (!this.marks)
      return [];
    const t = (s, i) => {
      const r = this.parseValue(s);
      return {
        pos: r,
        value: s,
        label: s,
        active: this.isActiveByPos(r),
        ...i
      };
    };
    return this.marks === !0 ? this.getValues().map((s) => t(s)) : Object.prototype.toString.call(this.marks) === "[object Object]" ? Object.keys(this.marks).sort((s, i) => +s - +i).map((s) => {
      const i = this.marks[s];
      return t(s, typeof i != "string" ? i : { label: i });
    }) : Array.isArray(this.marks) ? this.marks.map((s) => t(s)) : typeof this.marks == "function" ? this.getValues().map((s) => ({ value: s, result: this.marks(s) })).filter(({ result: s }) => !!s).map(({ value: s, result: i }) => t(s, i)) : [];
  }
  /**
   * Get the most recent slider index by position
   *
   * @param {number} pos
   * @returns {number}
   * @memberof Control
   */
  getRecentDot(t) {
    const s = this.dotsPos.map((i) => Math.abs(i - t));
    return s.indexOf(Math.min(...s));
  }
  /**
   * Get index by value
   *
   * @param {Value} value
   * @returns {number}
   * @memberof Control
   */
  getIndexByValue(t) {
    return this.data ? this.data.indexOf(t) : new f(+t).minus(this.min).divide(this.interval).toNumber();
  }
  /**
   * Get value by index
   *
   * @param {index} number
   * @returns {Value}
   * @memberof Control
   */
  getValueByIndex(t) {
    return t < 0 ? t = 0 : t > this.total && (t = this.total), this.data ? this.data[t] : new f(t).multiply(this.interval).plus(this.min).toNumber();
  }
  /**
   * Set the position of a single slider
   *
   * @param {number} pos
   * @param {number} index
   */
  setDotPos(t, s) {
    t = this.getValidPos(t, s).pos;
    const i = t - this.dotsPos[s];
    if (!i)
      return;
    let r = new Array(this.dotsPos.length);
    this.fixed ? r = this.getFixedChangePosArr(i, s) : this.minRange || this.maxRange ? r = this.getLimitRangeChangePosArr(t, i, s) : r[s] = i, this.setDotsPos(this.dotsPos.map((n, a) => n + (r[a] || 0)));
  }
  /**
   * In fixed mode, get the position of all slider changes
   *
   * @param {number} changePos Change distance of a single slider
   * @param {number} index slider index
   * @returns {DotsPosChangeArray}
   * @memberof Control
   */
  getFixedChangePosArr(t, s) {
    return this.dotsPos.forEach((i, r) => {
      if (r !== s) {
        const { pos: n, inRange: a } = this.getValidPos(i + t, r);
        a || (t = Math.min(Math.abs(n - i), Math.abs(t)) * (t < 0 ? -1 : 1));
      }
    }), this.dotsPos.map((i) => t);
  }
  /**
   * In minRange/maxRange mode, get the position of all slider changes
   *
   * @param {number} pos position of a single slider
   * @param {number} changePos Change distance of a single slider
   * @param {number} index slider index
   * @returns {DotsPosChangeArray}
   * @memberof Control
   */
  getLimitRangeChangePosArr(t, s, i) {
    const r = [{ index: i, changePos: s }], n = s;
    return [this.minRange, this.maxRange].forEach((a, m) => {
      if (!a)
        return !1;
      const o = m === 0, d = s > 0;
      let b = 0;
      o ? b = d ? 1 : -1 : b = d ? -1 : 1;
      const T = (P, U) => {
        const I = Math.abs(P - U);
        return o ? I < this.minRangeDir : I > this.maxRangeDir;
      };
      let v = i + b, V = this.dotsPos[v], L = t;
      for (; this.isPos(V) && T(V, L); ) {
        const { pos: P } = this.getValidPos(V + n, v);
        r.push({
          index: v,
          changePos: P - V
        }), v = v + b, L = P, V = this.dotsPos[v];
      }
    }), this.dotsPos.map((a, m) => {
      const o = r.filter((d) => d.index === m);
      return o.length ? o[0].changePos : 0;
    });
  }
  isPos(t) {
    return typeof t == "number";
  }
  /**
   * Get a valid position by pos
   *
   * @param {number} pos
   * @param {number} index
   * @returns {{ pos: number, inRange: boolean }}
   */
  getValidPos(t, s) {
    const i = this.valuePosRange[s];
    let r = !0;
    return t < i[0] ? (t = i[0], r = !1) : t > i[1] && (t = i[1], r = !1), {
      pos: t,
      inRange: r
    };
  }
  /**
   * Calculate the position of the slider by value
   *
   * @param {Value} val
   * @returns {number}
   */
  parseValue(t) {
    if (this.data)
      t = this.data.indexOf(t);
    else if (typeof t == "number" || typeof t == "string") {
      if (t = +t, t < this.min)
        return this.emitError(
          3
          /* MIN */
        ), 0;
      if (t > this.max)
        return this.emitError(
          4
          /* MAX */
        ), 0;
      if (typeof t != "number" || t !== t)
        return this.emitError(
          1
          /* VALUE */
        ), 0;
      t = new f(t).minus(this.min).divide(this.interval).toNumber();
    }
    const s = new f(t).multiply(this.gap).toNumber();
    return s < 0 ? 0 : s > 100 ? 100 : s;
  }
  /**
   * Calculate the value by position
   *
   * @param {number} pos
   * @returns {Value}
   * @memberof Control
   */
  parsePos(t) {
    const s = Math.round(t / this.gap);
    return this.getValueByIndex(s);
  }
  /**
   * Determine if the location is active
   *
   * @param {number} pos
   * @returns {boolean}
   * @memberof Control
   */
  isActiveByPos(t) {
    return this.processArray.some(([s, i]) => t >= s && t <= i);
  }
  /**
   * Get each value
   *
   * @returns {Value[]}
   * @memberof Control
   */
  getValues() {
    if (this.data)
      return this.data;
    {
      const t = [];
      for (let s = 0; s <= this.total; s++)
        t.push(new f(s).multiply(this.interval).plus(this.min).toNumber());
      return t;
    }
  }
  /**
   * Calculate the distance of the range
   * @param range number
   */
  getRangeDir(t) {
    return t ? new f(t).divide(
      new f(this.data ? this.data.length - 1 : this.max).minus(this.data ? 0 : this.min).toNumber()
    ).multiply(100).toNumber() : 100;
  }
  emitError(t) {
    this.onError && this.onError(t, st[t]);
  }
  get processArray() {
    if (this.process) {
      if (typeof this.process == "function")
        return this.process(this.dotsPos);
      if (this.dotsPos.length === 1)
        return [[0, this.dotsPos[0]]];
      if (this.dotsPos.length > 1)
        return [[Math.min(...this.dotsPos), Math.max(...this.dotsPos)]];
    }
    return [];
  }
  /**
   * The total number of values
   *
   * @type {number}
   * @memberof Control
   */
  get total() {
    let t = 0;
    return this.data ? t = this.data.length - 1 : t = new f(this.max).minus(this.min).divide(this.interval).toNumber(), t - Math.floor(t) !== 0 ? (this.emitError(
      2
      /* INTERVAL */
    ), 0) : t;
  }
  // Distance between each value
  get gap() {
    return 100 / this.total;
  }
  // The minimum distance between the two sliders
  get minRangeDir() {
    return this.cacheRangeDir[this.minRange] ? this.cacheRangeDir[this.minRange] : this.cacheRangeDir[this.minRange] = this.getRangeDir(this.minRange);
  }
  // Maximum distance between the two sliders
  get maxRangeDir() {
    return this.cacheRangeDir[this.maxRange] ? this.cacheRangeDir[this.maxRange] : this.cacheRangeDir[this.maxRange] = this.getRangeDir(this.maxRange);
  }
  getDotRange(t, s, i) {
    if (!this.dotOptions)
      return i;
    const r = Array.isArray(this.dotOptions) ? this.dotOptions[t] : this.dotOptions;
    return r && r[s] !== void 0 ? this.parseValue(r[s]) : i;
  }
  /**
   * Sliding range of each slider
   *
   * @type {Array<[number, number]>}
   * @memberof Control
   */
  get valuePosRange() {
    const t = this.dotsPos, s = [];
    return t.forEach((i, r) => {
      s.push([
        Math.max(
          this.minRange ? this.minRangeDir * r : 0,
          this.enableCross ? 0 : t[r - 1] || 0,
          this.getDotRange(r, "min", 0)
        ),
        Math.min(
          this.minRange ? 100 - this.minRangeDir * (t.length - 1 - r) : 100,
          this.enableCross ? 100 : t[r + 1] || 100,
          this.getDotRange(r, "max", 100)
        )
      ]);
    }), s;
  }
  get dotsIndex() {
    return this.dotsValue.map((t) => this.getIndexByValue(t));
  }
}
class rt {
  constructor(t) {
    l(this, "map");
    l(this, "states", 0);
    this.map = t;
  }
  add(t) {
    this.states |= t;
  }
  delete(t) {
    this.states &= ~t;
  }
  toggle(t) {
    this.has(t) ? this.delete(t) : this.add(t);
  }
  has(t) {
    return !!(this.states & t);
  }
}
const h = {
  None: 0,
  Drag: 2,
  Focus: 4
}, w = 4, ot = C({
  name: "VueSlider",
  components: {
    VueSliderDot: H,
    VueSliderMark: N
  },
  emits: ["change", "drag-start", "dragging", "drag-end", "error", "update:modelValue"],
  data() {
    return {
      control: null,
      states: new rt(h),
      // The width of the component is divided into one hundred, the width of each one.
      scale: 1,
      // Currently dragged slider index
      focusDotIndex: 0
    };
  },
  props: {
    modelValue: {
      type: [Number, String, Array],
      default: 0
    },
    silent: { type: Boolean, default: !1 },
    direction: {
      type: String,
      default: "ltr",
      validator: (e) => ["ltr", "rtl", "ttb", "btt"].indexOf(e) > -1
    },
    width: { type: [Number, String] },
    height: { type: [Number, String] },
    // The size of the slider, optional [width, height] | size
    dotSize: {
      type: [Number, Array],
      default: 14
    },
    // whether or not the slider should be fully contained within its containing element
    contained: { type: Boolean, default: !1 },
    min: { type: Number, default: 0 },
    max: { type: Number, default: 100 },
    interval: { type: Number, default: 1 },
    disabled: { type: Boolean, default: !1 },
    clickable: { type: Boolean, default: !0 },
    dragOnClick: { type: Boolean, default: !1 },
    duration: { type: Number, default: 0.5 },
    data: {
      type: [Object, Array]
    },
    dataValue: { type: String, default: "value" },
    dataLabel: { type: String, default: "label" },
    lazy: { type: Boolean, default: !1 },
    tooltip: {
      type: String,
      default: "active",
      validator: (e) => ["none", "always", "focus", "hover", "active"].indexOf(e) > -1
    },
    tooltipPlacement: {
      type: [String, Array],
      validator: (e) => (Array.isArray(e) ? e : [e]).every(
        (t) => ["top", "right", "bottom", "left"].indexOf(t) > -1
      )
    },
    tooltipFormatter: {
      type: [String, Array, Function]
    },
    // Keyboard control
    useKeyboard: { type: Boolean, default: !0 },
    // Keyboard controlled hook function
    keydownHook: {
      // eslint-disable-next-line no-unused-vars
      type: Function
    },
    // Whether to allow sliders to cross, only in range mode
    enableCross: { type: Boolean, default: !0 },
    // Whether to fix the slider interval, only in range mode
    fixed: { type: Boolean, default: !1 },
    // Whether to sort values, only in range mode
    // When order is false, the parameters [minRange, maxRange, fixed, enableCross] are invalid
    // e.g. When order = false, [50, 30] will not be automatically sorted into [30, 50]
    order: { type: Boolean, default: !0 },
    // Minimum distance between sliders, only in range mode
    minRange: { type: Number },
    // Maximum distance between sliders, only in range mode
    maxRange: { type: Number },
    marks: {
      type: [Boolean, Object, Array, Function],
      default: !1
    },
    process: {
      type: [Boolean, Function],
      default: !0
    },
    zoom: { type: Number },
    // If the value is true , mark will be an independent value
    included: { type: Boolean },
    // If the value is true , dot will automatically adsorb to the nearest value
    adsorb: { type: Boolean },
    hideLabel: { type: Boolean },
    // Slider settings, multiple sliders can be distinguished by array type.
    dotOptions: {
      type: [Object, Array]
    },
    // Set custom attributes on the slider.
    dotAttrs: { type: Object },
    railStyle: { type: Object },
    processStyle: { type: Object },
    dotStyle: { type: Object },
    tooltipStyle: { type: Object },
    stepStyle: { type: Object },
    stepActiveStyle: { type: Object },
    labelStyle: { type: Object },
    labelActiveStyle: { type: Object }
  },
  computed: {
    isHorizontal() {
      return this.direction === "ltr" || this.direction === "rtl";
    },
    isReverse() {
      return this.direction === "rtl" || this.direction === "btt";
    },
    tailSize() {
      return A((this.isHorizontal ? this.height : this.width) || w);
    },
    containerClasses() {
      return [
        "vue-slider",
        [`vue-slider-${this.direction}`],
        {
          "vue-slider-disabled": this.disabled
        }
      ];
    },
    containerStyles() {
      const [e, t] = Array.isArray(this.dotSize) ? this.dotSize : [this.dotSize, this.dotSize], s = this.width ? A(this.width) : this.isHorizontal ? "auto" : A(w), i = this.height ? A(this.height) : this.isHorizontal ? A(w) : "auto";
      return {
        padding: this.contained ? `${t / 2}px ${e / 2}px` : this.isHorizontal ? `${t / 2}px 0` : `0 ${e / 2}px`,
        width: s,
        height: i
      };
    },
    processArray() {
      return this.control.processArray.map(([e, t, s], i) => {
        e > t && ([e, t] = [t, e]);
        const r = this.isHorizontal ? "width" : "height";
        return {
          start: e,
          end: t,
          index: i,
          style: {
            [this.isHorizontal ? "height" : "width"]: "100%",
            [this.isHorizontal ? "top" : "left"]: 0,
            [this.mainDirection]: `${e}%`,
            [r]: `${t - e}%`,
            transitionProperty: `${r},${this.mainDirection}`,
            transitionDuration: `${this.animateTime}s`,
            ...this.processStyle,
            ...s
          }
        };
      });
    },
    dotBaseStyle() {
      const [e, t] = Array.isArray(this.dotSize) ? this.dotSize : [this.dotSize, this.dotSize];
      let s;
      return this.isHorizontal ? s = {
        transform: `translate(${this.isReverse ? "50%" : "-50%"}, -50%)`,
        WebkitTransform: `translate(${this.isReverse ? "50%" : "-50%"}, -50%)`,
        top: "50%",
        [this.direction === "ltr" ? "left" : "right"]: "0"
      } : s = {
        transform: `translate(-50%, ${this.isReverse ? "50%" : "-50%"})`,
        WebkitTransform: `translate(-50%, ${this.isReverse ? "50%" : "-50%"})`,
        left: "50%",
        [this.direction === "btt" ? "bottom" : "top"]: "0"
      }, {
        width: `${e}px`,
        height: `${t}px`,
        ...s
      };
    },
    mainDirection() {
      switch (this.direction) {
        case "ltr":
          return "left";
        case "rtl":
          return "right";
        case "btt":
          return "bottom";
        case "ttb":
          return "top";
        default:
          return "left";
      }
    },
    tooltipDirections() {
      const e = this.tooltipPlacement || (this.isHorizontal ? "top" : "left");
      return Array.isArray(e) ? e : this.dots.map(() => e);
    },
    dots() {
      return this.control.dotsPos.map((e, t) => ({
        pos: e,
        index: t,
        value: this.control.dotsValue[t],
        focus: this.states.has(h.Focus) && this.focusDotIndex === t,
        disabled: this.disabled,
        style: this.dotStyle,
        ...(Array.isArray(this.dotOptions) ? this.dotOptions[t] : this.dotOptions) || {}
      }));
    },
    animateTime() {
      return this.states.has(h.Drag) ? 0 : this.duration;
    },
    canSort() {
      return this.order && !this.minRange && !this.maxRange && !this.fixed && this.enableCross;
    },
    sliderData() {
      return this.isObjectArrayData(this.data) ? this.data.map((e) => e[this.dataValue]) : this.isObjectData(this.data) ? Object.keys(this.data) : this.data;
    },
    sliderMarks() {
      return this.marks ? this.marks : this.isObjectArrayData(this.data) ? (e) => {
        const t = { label: e };
        return this.data.some((s) => s[this.dataValue] === e ? (t.label = s[this.dataLabel], !0) : !1), t;
      } : this.isObjectData(this.data) ? this.data : void 0;
    },
    sliderTooltipFormatter() {
      if (this.tooltipFormatter)
        return this.tooltipFormatter;
      if (this.isObjectArrayData(this.data))
        return (e) => {
          let t = "" + e;
          return this.data.some((s) => s[this.dataValue] === e ? (t = s[this.dataLabel], !0) : !1), t;
        };
      if (this.isObjectData(this.data)) {
        const e = this.data;
        return (t) => e[t];
      } else
        return;
    },
    // Slider value and component internal value are inconsistent
    isNotSync() {
      const e = this.control.dotsValue;
      return Array.isArray(this.modelValue) ? this.modelValue.length !== e.length || this.modelValue.some((t, s) => t !== e[s]) : this.modelValue !== e[0];
    },
    /**
     * Get the drag range of the slider
     *
     * @private
     * @param {number} index slider index
     * @returns {[number, number]} range [start, end]
     * @memberof VueSlider
     */
    dragRange() {
      const e = this.dots[this.focusDotIndex - 1], t = this.dots[this.focusDotIndex + 1];
      return [e ? e.pos : -1 / 0, t ? t.pos : 1 / 0];
    }
  },
  watch: {
    modelValue() {
      this.control && !this.states.has(h.Drag) && this.isNotSync && this.control.setValue(this.modelValue);
    }
  },
  methods: {
    isObjectData(e) {
      return !!e && Object.prototype.toString.call(e) === "[object Object]";
    },
    isObjectArrayData(e) {
      return !!e && Array.isArray(e) && e.length > 0 && typeof e[0] == "object";
    },
    bindEvent() {
      document.addEventListener("touchmove", this.dragMove, { passive: !1 }), document.addEventListener("touchend", this.dragEnd, { passive: !1 }), document.addEventListener("mousedown", this.blurHandle), document.addEventListener("mousemove", this.dragMove), document.addEventListener("mouseup", this.dragEnd), document.addEventListener("mouseleave", this.dragEnd), document.addEventListener("keydown", this.keydownHandle);
    },
    unbindEvent() {
      document.removeEventListener("touchmove", this.dragMove), document.removeEventListener("touchend", this.dragEnd), document.removeEventListener("mousedown", this.blurHandle), document.removeEventListener("mousemove", this.dragMove), document.removeEventListener("mouseup", this.dragEnd), document.removeEventListener("mouseleave", this.dragEnd), document.removeEventListener("keydown", this.keydownHandle);
    },
    setScale() {
      this.scale = new f(
        Math.floor(this.isHorizontal ? this.$el.offsetWidth : this.$el.offsetHeight)
      ).multiply(this.zoom || 1).divide(100).toNumber();
    },
    initControl() {
      this.control = new it({
        value: this.modelValue,
        data: this.sliderData,
        enableCross: this.enableCross,
        fixed: this.fixed,
        max: this.max,
        min: this.min,
        interval: this.interval,
        minRange: this.minRange,
        maxRange: this.maxRange,
        order: this.order,
        marks: this.sliderMarks,
        included: this.included,
        process: this.process,
        adsorb: this.adsorb,
        dotOptions: this.dotOptions,
        onError: this.emitError
      }), [
        "data",
        "enableCross",
        "fixed",
        "max",
        "min",
        "interval",
        "minRange",
        "maxRange",
        "order",
        "marks",
        "process",
        "adsorb",
        "included",
        "dotOptions"
      ].forEach((e) => {
        this.$watch(e, (t) => {
          if (e === "data" && Array.isArray(this.control.data) && Array.isArray(t) && this.control.data.length === t.length && t.every((s, i) => s === this.control.data[i]))
            return !1;
          switch (e) {
            case "data":
            case "dataLabel":
            case "dataValue":
              this.control.data = this.sliderData;
              break;
            case "mark":
              this.control.marks = this.sliderMarks;
              break;
            default:
              this.control[e] = t;
          }
          ["data", "max", "min", "interval"].indexOf(e) > -1 && this.control.syncDotsPos();
        });
      });
    },
    syncValueByPos() {
      const e = this.control.dotsValue;
      if (this.isDiff(e, Array.isArray(this.modelValue) ? this.modelValue : [this.modelValue])) {
        const t = e.length === 1 ? e[0] : [...e];
        this.$emit("change", t, this.focusDotIndex), this.$emit("update:modelValue", t);
      }
    },
    isDiff(e, t) {
      return e.length !== t.length || e.some((s, i) => s !== t[i]);
    },
    emitError(e, t) {
      this.silent || console.error(`[VueSlider error]: ${t}`), this.$emit("error", e, t);
    },
    dragStartOnProcess(e) {
      if (this.dragOnClick) {
        this.setScale();
        const t = this.getPosByEvent(e), s = this.control.getRecentDot(t);
        if (this.dots[s].disabled)
          return;
        this.dragStart(s), this.control.setDotPos(t, this.focusDotIndex), this.lazy || this.syncValueByPos();
      }
    },
    dragStart(e) {
      this.focusDotIndex = e, this.setScale(), this.states.add(h.Drag), this.states.add(h.Focus), this.$emit("drag-start", this.focusDotIndex);
    },
    dragMove(e) {
      if (!this.states.has(h.Drag))
        return !1;
      e.preventDefault();
      const t = this.getPosByEvent(e);
      this.isCrossDot(t), this.control.setDotPos(t, this.focusDotIndex), this.lazy || this.syncValueByPos();
      const s = this.control.dotsValue;
      this.$emit("dragging", s.length === 1 ? s[0] : [...s], this.focusDotIndex);
    },
    // If the component is sorted, then when the slider crosses, toggle the currently selected slider index
    isCrossDot(e) {
      if (this.canSort) {
        const t = this.focusDotIndex;
        let s = e;
        if (s > this.dragRange[1] ? (s = this.dragRange[1], this.focusDotIndex++) : s < this.dragRange[0] && (s = this.dragRange[0], this.focusDotIndex--), t !== this.focusDotIndex) {
          const i = this.$refs[`dot-${this.focusDotIndex}`];
          i && i.$el && i.$el.focus(), this.control.setDotPos(s, t);
        }
      }
    },
    dragEnd(e) {
      if (!this.states.has(h.Drag))
        return !1;
      setTimeout(() => {
        this.lazy && this.syncValueByPos(), this.included && this.isNotSync ? this.control.setValue(this.modelValue) : this.control.syncDotsPos(), this.states.delete(h.Drag), (!this.useKeyboard || "targetTouches" in e) && this.states.delete(h.Focus), this.$emit("drag-end", this.focusDotIndex);
      });
    },
    blurHandle(e) {
      if (!this.states.has(h.Focus) || !this.$refs.container || this.$refs.container.contains(e.target))
        return !1;
      this.states.delete(h.Focus);
    },
    clickHandle(e) {
      if (!this.clickable || this.disabled)
        return !1;
      if (this.states.has(h.Drag))
        return;
      this.setScale();
      const t = this.getPosByEvent(e);
      this.setValueByPos(t);
    },
    focus(e, t = 0) {
      e.disabled || (this.states.add(h.Focus), this.focusDotIndex = t);
    },
    blur() {
      this.states.delete(h.Focus);
    },
    getValue() {
      const e = this.control.dotsValue;
      return e.length === 1 ? e[0] : e;
    },
    getIndex() {
      const e = this.control.dotsIndex;
      return e.length === 1 ? e[0] : e;
    },
    setValue(e) {
      this.control.setValue(Array.isArray(e) ? [...e] : [e]), this.syncValueByPos();
    },
    setIndex(e) {
      const t = Array.isArray(e) ? e.map((s) => this.control.getValueByIndex(s)) : this.control.getValueByIndex(e);
      this.setValue(t);
    },
    setValueByPos(e) {
      const t = this.control.getRecentDot(e);
      if (this.disabled || this.dots[t].disabled)
        return !1;
      this.focusDotIndex = t, this.control.setDotPos(e, t), this.syncValueByPos(), this.useKeyboard && this.states.add(h.Focus), setTimeout(() => {
        this.included && this.isNotSync ? this.control.setValue(this.modelValue) : this.control.syncDotsPos();
      });
    },
    keydownHandle(e) {
      if (!this.useKeyboard || !this.states.has(h.Focus))
        return !1;
      const t = this.included && this.marks, s = tt(e, {
        direction: this.direction,
        max: t ? this.control.markList.length - 1 : this.control.total,
        min: 0,
        hook: this.keydownHook
      });
      if (s) {
        e.preventDefault();
        let i = -1, r = 0;
        t ? (this.control.markList.some((n, a) => n.value === this.control.dotsValue[this.focusDotIndex] ? (i = s(a), !0) : !1), i < 0 ? i = 0 : i > this.control.markList.length - 1 && (i = this.control.markList.length - 1), r = this.control.markList[i].pos) : (i = s(
          this.control.getIndexByValue(this.control.dotsValue[this.focusDotIndex])
        ), r = this.control.parseValue(this.control.getValueByIndex(i))), this.isCrossDot(r), this.control.setDotPos(r, this.focusDotIndex), this.syncValueByPos();
      }
    },
    getPosByEvent(e) {
      return _(e, this.$el, this.isReverse, this.zoom)[this.isHorizontal ? "x" : "y"] / this.scale;
    },
    renderSlot(e, t, s) {
      const i = this.$slots[e];
      return i ? i(t) : s;
    }
  },
  created() {
    this.initControl();
  },
  mounted() {
    this.bindEvent();
  },
  beforeUnmount() {
    this.unbindEvent();
  }
}), at = {
  key: 0,
  class: "vue-slider-marks"
};
function nt(e, t, s, i, r, n) {
  const a = z("vue-slider-mark"), m = z("vue-slider-dot");
  return u(), p("div", M({
    ref: "container",
    class: e.containerClasses,
    style: e.containerStyles,
    onClick: t[2] || (t[2] = (...o) => e.clickHandle && e.clickHandle(...o)),
    onTouchstartPassive: t[3] || (t[3] = (...o) => e.dragStartOnProcess && e.dragStartOnProcess(...o)),
    onMousedownPassive: t[4] || (t[4] = (...o) => e.dragStartOnProcess && e.dragStartOnProcess(...o))
  }, e.$attrs), [
    k("div", {
      class: "vue-slider-rail",
      style: g(e.railStyle)
    }, [
      (u(!0), p(R, null, O(e.processArray, (o, d) => c(e.$slots, "process", S(D(o)), () => [
        (u(), p("div", {
          class: "vue-slider-process",
          key: `process-${d}`,
          style: g(o.style)
        }, null, 4))
      ])), 256)),
      e.sliderMarks && e.control ? (u(), p("div", at, [
        (u(!0), p(R, null, O(e.control.markList, (o, d) => c(e.$slots, "mark", S(D(o)), () => [
          (u(), F(a, {
            key: `mark-${d}`,
            mark: o,
            hideLabel: e.hideLabel,
            style: g({
              [e.isHorizontal ? "height" : "width"]: "100%",
              [e.isHorizontal ? "width" : "height"]: e.tailSize,
              [e.mainDirection]: `${o.pos}%`
            }),
            stepStyle: e.stepStyle,
            stepActiveStyle: e.stepActiveStyle,
            labelStyle: e.labelStyle,
            labelActiveStyle: e.labelActiveStyle,
            onPressLabel: t[0] || (t[0] = (b) => e.clickable && e.setValueByPos(b))
          }, {
            step: $(() => [
              c(e.$slots, "step", S(D(o)))
            ]),
            label: $(() => [
              c(e.$slots, "label", S(D(o)))
            ]),
            _: 2
          }, 1032, ["mark", "hideLabel", "style", "stepStyle", "stepActiveStyle", "labelStyle", "labelActiveStyle"]))
        ])), 256))
      ])) : B("", !0),
      (u(!0), p(R, null, O(e.dots, (o, d) => (u(), F(m, M({
        ref_for: !0,
        ref: `dot-${d}`,
        key: `dot-${d}`,
        value: o.value,
        disabled: o.disabled,
        focus: o.focus,
        "dot-style": [
          o.style,
          o.disabled ? o.disabledStyle : null,
          o.focus ? o.focusStyle : null
        ],
        tooltip: o.tooltip || e.tooltip,
        "tooltip-style": [
          e.tooltipStyle,
          o.tooltipStyle,
          o.disabled ? o.tooltipDisabledStyle : null,
          o.focus ? o.tooltipFocusStyle : null
        ],
        "tooltip-formatter": Array.isArray(e.sliderTooltipFormatter) ? e.sliderTooltipFormatter[d] : e.sliderTooltipFormatter,
        "tooltip-placement": e.tooltipDirections[d],
        style: [
          e.dotBaseStyle,
          {
            [e.mainDirection]: `${o.pos}%`,
            transition: `${e.mainDirection} ${e.animateTime}s`
          }
        ],
        onDragStart: () => e.dragStart(d),
        role: "slider",
        "aria-valuenow": o.value,
        "aria-valuemin": e.min,
        "aria-valuemax": e.max,
        "aria-orientation": e.isHorizontal ? "horizontal" : "vertical",
        tabindex: "0",
        onFocus: () => e.focus(o, d),
        onBlur: t[1] || (t[1] = () => e.blur())
      }, e.dotAttrs), {
        dot: $(() => [
          c(e.$slots, "dot", S(D(o)))
        ]),
        tooltip: $(() => [
          c(e.$slots, "tooltip", S(D(o)))
        ]),
        _: 2
      }, 1040, ["value", "disabled", "focus", "dot-style", "tooltip", "tooltip-style", "tooltip-formatter", "tooltip-placement", "style", "onDragStart", "aria-valuenow", "aria-valuemin", "aria-valuemax", "aria-orientation", "onFocus"]))), 128))
    ], 4),
    c(e.$slots, "default", {
      value: e.getValue()
    })
  ], 16);
}
const x = /* @__PURE__ */ E(ot, [["render", nt]]);
x.VueSliderMark = N;
x.VueSliderDot = H;
export {
  et as ERROR_TYPE,
  H as VueSliderDot,
  N as VueSliderMark,
  x as default
};
